using System;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;
using System.Xml;
using System.Xml.Serialization;

namespace PSP
{
	/// <summary>
	/// ۑF10A_CS
	///     90%70%̗\sB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	public class Estimate 
	{
		public int		NewLOC;
		public int		ReuseLOC;
		public int		UpdateLOC;
	}
	public class LOC 
	{
		public int		No;
		public int		NewLOC;
		public int		ReuseLOC;
		public int		UpdateLOC;
		public double	Time;
	}
	public class Data 
	{
		public Estimate	Estimate;
		public LOC[]	ArrayOfLOC;
	}
	class C10A_CS
	{
#if C10A_CS
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","10A_CS",new Delegate(Main),false);
				return;
			}
			CLinkList	l = new CLinkList();
			Estimate	est;
			if (!ReadData(args[0],l,out est)) return;
			if (l.Count <= 4) return;
			WriteResult(l,est);
		}
#endif
		/// <summary>
		/// t@Cf[^Ǎ݂܂B
		/// </summary>
		public static bool ReadData(string fnam,CLinkList l,out Estimate est)
		{
			// t@CJ
			try 
			{
				XmlSerializer xr = new XmlSerializer(typeof(Data));
				StreamReader sr = new StreamReader(fnam);
				Data data = (Data)xr.Deserialize(sr);
				sr.Close();
				foreach (LOC d in data.ArrayOfLOC) l.Add(d);
				est = data.Estimate;
			}
			catch (FileNotFoundException e) 
			{
				Console.Error.WriteLine(e.Message);
				est = null;
				return false;
			}
			return true;
		}
		public static void WriteResult(CLinkList l,Estimate est)
		{
			double	d,e,dlt,s,w,x,y,z,ww,wx,wy,wz,xx,xy,xz,yy,yz;
			w = x = y = z = ww = wx = wy = wz = xx = xy = xz = yy = yz = 0;
			foreach (LOC dt in l) 
			{
				w += dt.NewLOC;
				x += dt.ReuseLOC;
				y += dt.UpdateLOC;
				z += dt.Time;
				ww += dt.NewLOC * dt.NewLOC;
				wx += dt.NewLOC * dt.ReuseLOC;
				wy += dt.NewLOC * dt.UpdateLOC;
				wz += dt.NewLOC * dt.Time;
				xx += dt.ReuseLOC * dt.ReuseLOC;
				xy += dt.ReuseLOC * dt.UpdateLOC;
				xz += dt.ReuseLOC * dt.Time;
				yy += dt.UpdateLOC * dt.UpdateLOC;
				yz += dt.UpdateLOC * dt.Time;
			}
			int			i,j,k, n = l.Count;
			double[]	b = new double[4];
			double[,]	a = new double[4,5]{{n,w,x,y,z},{w,ww,wx,wy,wz},{x,wx,xx,xy,xz},{y,wy,xy,yy,yz}};
			for (i=0;i<4;++i) 
			{
				for (j=i+1;j<5;++j)
					a[i,j] /= a[i,i];
				for (j=i+1;j<4;++j) 
				{
					for (k=i+1;k<5;++k)
						a[j,k] -= a[i,k] * a[j,i];
				}
			}
			for (i=3;i>0;--i) 
			{
				for (j=0;j<i;++j) a[j,4] -= a[i,4] * a[j,i];
			}
			for (i=0;i<4;++i) b[i] = a[i,4];
			dlt = 0;
			foreach (LOC dt in l)
			{
				d = dt.Time  - b[0] - b[1]*dt.NewLOC - b[2]*dt.ReuseLOC - b[3]*dt.UpdateLOC;
				dlt += d*d;
			}
			dlt = Math.Sqrt(dlt / (n-4));
			w /= n; x /= n; y /= n;
			s = Math.Sqrt(1 + 1.0/n + (est.NewLOC-w)*(est.NewLOC-w)/(ww-n*w*w)
				+ (est.ReuseLOC-x)*(est.ReuseLOC-x)/(xx-n*x*x)
				+ (est.UpdateLOC-y)*(est.UpdateLOC-y)/(yy-n*y*y));
			e = b[0] + b[1]*est.NewLOC + b[2]*est.ReuseLOC + b[3]*est.UpdateLOC;
			Console.WriteLine("0 {0:F5}\n1 {1:F5}\n2 {2:F5}\n3 {3:F5}\nEst {4:F2}",
				b[0],b[1],b[2],b[3],e);
			double[]	rr = {0.7, 0.9};
			foreach (double r in rr) 
			{
				double g = dlt * s * CalcRevT(0.5+r/2, l.Count-4);
				Console.WriteLine("{0}% {1:F2} ` {2:F2}",(int)(r*100+.5),e-g,e+g);
			}
		}
		public static double FuncT(double x,object o)
		{
			int	n = (int)o;
			return Math.Pow(1+x*x/n,-(n+1)/2.0);
		}
		public static double GFunc(double x,int n)
		{
			return 0.5 + Math.Exp(lngamma((n+1)/2.0) - lngamma(n/2.0)) / Math.Sqrt(n * Math.PI)
				* C05A_CS.Simpson(new CalcFunc(FuncT),0,x,n);
		}
		public static double CalcRevT(double x,int n)
		{
			double		v, m = 0, lo = 0, up = 3;
			int			cnt = 0;
			while (GFunc(up,n) < x) up *= 2;
			while (up - lo > 1e-8 && ++cnt < 64) 
			{
				m = (up+lo)/2;
				v = GFunc(m,n);
				if (v < x) lo = m;
				else up = m;
			}
			return m;
		}
		/// <summary>
		/// (x) = Math.Exp(lngamma(x))
		/// </summary>
		public static double lngamma(double xx)
		{
			double[]	cof = {
								  76.18009173,-86.50532033,24.01409822,
								  -1.231739516,0.120858003e-2,-0.536382e-5};
			double	x = xx-1.0;
			double	tmp = x+5.5;
			tmp -= (x+0.5)*Math.Log(tmp);
			double	ser = 1.0;
			for (int j=0;j<=5;j++) { x += 1.0; ser += cof[j]/x; }
			return -tmp+Math.Log(2.50662827465*ser);
		}
	}
}
